##############################################################################
# 
# Zope Public License (ZPL) Version 1.0
# -------------------------------------
# 
# Copyright (c) Digital Creations.  All rights reserved.
# 
# This license has been certified as Open Source(tm).
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
# 
# 1. Redistributions in source code must retain the above copyright
#    notice, this list of conditions, and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions, and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
# 
# 3. Digital Creations requests that attribution be given to Zope
#    in any manner possible. Zope includes a "Powered by Zope"
#    button that is installed by default. While it is not a license
#    violation to remove this button, it is requested that the
#    attribution remain. A significant investment has been put
#    into Zope, and this effort will continue if the Zope community
#    continues to grow. This is one way to assure that growth.
# 
# 4. All advertising materials and documentation mentioning
#    features derived from or use of this software must display
#    the following acknowledgement:
# 
#      "This product includes software developed by Digital Creations
#      for use in the Z Object Publishing Environment
#      (http://www.zope.org/)."
# 
#    In the event that the product being advertised includes an
#    intact Zope distribution (with copyright and license included)
#    then this clause is waived.
# 
# 5. Names associated with Zope or Digital Creations must not be used to
#    endorse or promote products derived from this software without
#    prior written permission from Digital Creations.
# 
# 6. Modified redistributions of any form whatsoever must retain
#    the following acknowledgment:
# 
#      "This product includes software developed by Digital Creations
#      for use in the Z Object Publishing Environment
#      (http://www.zope.org/)."
# 
#    Intact (re-)distributions of any official Zope release do not
#    require an external acknowledgement.
# 
# 7. Modifications are encouraged but must be packaged separately as
#    patches to official Zope releases.  Distributions that do not
#    clearly separate the patches from the original work must be clearly
#    labeled as unofficial distributions.  Modifications which do not
#    carry the name Zope may be packaged in any form, as long as they
#    conform to all of the clauses above.
# 
# 
# Disclaimer
# 
#   THIS SOFTWARE IS PROVIDED BY DIGITAL CREATIONS ``AS IS'' AND ANY
#   EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
#   PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL DIGITAL CREATIONS OR ITS
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# 
# 
# This software consists of contributions made by Digital Creations and
# many individuals on behalf of Digital Creations.  Specific
# attributions are listed in the accompanying credits file.
# 
##############################################################################

'''$Id: db.py,v 1.8 1999/11/23 15:41:31 petrilli Exp $'''
__version__='$Revision: 1.8 $'[11:-2]

import kinterbasdb, DateTime
from Shared.DC.ZRDB.TM import TM

import string, sys
strsplit=string.split
from string import strip, find
from time import time

failures=0
calls=0
last_call_time=time()

class DB(TM):

    _p_oid=_p_changed=_registered=None

    Database_Connection=kinterbasdb.connect
    Database_Error=kinterbasdb.Error

    def __init__(self,connection):
        self.connection=connection
	#---
	# parse the connection string
	#---
	self.setup()

    def setup(self):
	try:
	    self.cursor.close()
	except:
	    pass
	try:
	    self.db.close()
	except:
	    pass
	connbits=strsplit(self.connection, ' ')
	db=kinterbasdb.connect(dsn=connbits[0],user=connbits[1],password=connbits[2])
	self.db=db
	self.cursor=self.db.cursor()
        
    def str(self,v, StringType=type('')):
        if v is None: return ''
        r=str(v)
        if r[-1:]=='L' and type(v) is not StringType: r=r[:-1]
        return r

    def _finish(self, *ignored):
	pass
        #self.db.commit()

    def _abort(self, *ignored):
	pass
        #self.db.rollback()

    def tables(self, rdb=0,
               _care=('TABLE', 'VIEW')):
        r=[]
        a=r.append
	c=self.db.cursor()
	c.execute('''SELECT RDB$RELATION_NAME FROM RDB$RELATIONS WHERE ( NOT (RDB$RELATION_NAME STARTING WITH 'RDB$') ) ORDER BY 1''')

	tabs=c.fetchall()
	for tab in tabs:
	    a({'TABLE_NAME': tab[0], 'TABLE_TYPE': 'TABLE'})
	return r

    def columns(self, table_name):
        c=self.cursor
	try: r=c.execute('''select  r.rdb$field_name field_name, t.rdb$type_name type_name, 
	 f.rdb$field_length field_length, f.rdb$field_sub_type field_sub_type, 
	 f.rdb$null_flag null_flag, rdb$field_precision field_precision,
	 f.rdb$field_scale field_scale, f.rdb$default_source default_value
 from    rdb$relation_fields r, rdb$types t, rdb$fields f
 where   r.rdb$relation_name='%s' and
	 f.rdb$field_name=r.rdb$field_source and
	 t.rdb$field_name='RDB$FIELD_TYPE' and
	 f.rdb$field_type=t.rdb$type;''' % table_name)
	except: 
	    self.setup()
	    return ()
		
	rows=c.fetchallmap()
	r=[]
	a=r.append
	for row in rows:
	    name=row['field_name']
	    typ=strip(row['type_name'])
	    p=row['field_length']
	    scale=row['field_scale']
	    null_ok=row['null_flag'] is not None and 'Nullable' or ''
	    default=row['default_value']
	    print "'%s'" % typ
	    if strip(typ)=='VARYING': 
		typ='VARCHAR'
	    subtyp=''
	    if typ=='BLOB':
	        subtyp=row['field_sub_type']
		c.execute('select rdb$type_name from rdb$types where rdb$type=%s' % subtyp)
		subtyp=c.fetchall()
		print subtyp
		subtyp=strip(subtyp[0][0])
	    a({ 'Name': name,
		'Type': typ,
		'Precision': p,
		'Scale': scale,
		'Nullable': null_ok,
		'Default': default,
		'SubType': subtyp,
		})

        return r

    def query(self,query_string, max_rows=9999999):
        global failures, calls, last_call_time
        calls=calls+1
        desc=None
        result=()
        self._register()
        c=self.cursor
	try:
	    for qs in filter(None, map(strip,strsplit(query_string, '\0'))):
		r=c.execute(qs)
		if r is None:
		    if desc is not None:
			if c.description != desc:
			    raise 'Query Error', ( 'Multiple select schema are not allowed')
			if type(result) is not ListType: result=list(result)
			if max_rows:
			    for row in c.fetchmany(max_rows-len(result)):
				result.append(row)
		    else:
			desc=c.description
			if max_rows:
			    if max_rows==1: result=(c.fetchone(),)
			    else: result=c.fetchmany(max_rows)
				
	    failures=0
	    last_call_time=time()
	except self.Database_Error, mess:
	    self.setup()
	    raise sys.exc_type, sys.exc_value, sys.exc_traceback

        if desc is None: return (),()

        items=[]
        for name, type, width, ds, p, scale, null_ok in desc:
            if type=='NUMBER':
                if scale==0: type='i'
                else: type='n'
            elif type=='DATE':
                type='d'
            else: type='s'
            items.append({
                'name': name,
                'type': type,
                'width': width,
                'null': null_ok,
                })
        return items, result


